
;;  -------------------------------------------------------------------
;;  NOM:        PANTALLA.INC
;;  CREAT PER:  Coordinador EC I (2000/2001)
;;  DATA:       02/MAR/2001
;;  DESCRIPCIO: fitxer amb la declaraci, en format assemblador, de
;;              les subrutines que permeten accedir a pantalla en mode
;;              text 80x25.
;;  -------------------------------------------------------------------



;       Declaraci de PROCEDIMENTS pblics del mdul:


EXTRN _IniPantalla:FAR
        ;  Retorna l'adrea de memria on est mapejada la pantalla. Emmagat-
        ;  zema internament aquesta informaci per a que sigui usada per les
        ;  rutines posteriors. En cas que el mode de pantalla no sigui reco-
        ;  negut retorna el valor 0000:0000 que indica que s'ha produt un
        ;  error. El valor retornat es pot utilitzar, a ms, per saber si es
        ;  tracta d'un sistema color o monocrom.
        ;       Declaraci en C:
        ;               ADR IniPantalla (void);


EXTRN _EscriureCar:FAR
        ;  Escriu a pantalla el carcter que se li passa, amb l'atribut
        ;  indicat, a les coordenades especificades. La informaci d'on
        ;  es troba mapejada la pantalla l'obt de la variable que ha
        ;  inicialitzat la rutina _IniPantalla.
        ;       Declaraci en C:
        ;               void EscriureCar (BYTE fila, BYTE columna,
        ;                                 char caracter, BYTE atribut);


EXTRN _EscriureString:FAR
        ;  Escriu a pantalla la cadena de carcters que se li passa, a
        ;  partir de la posici donada, i amb el mateix atribut per a tots
        ;  els carcters. La seva implementaci pot utilitzar instruccions
        ;  de tractament de strings de l'i8086 (LODSB i STOSW). La informa-
        ;  ci d'on es troba mapejada la pantalla l'obt de la variable que
        ;  ha inicialitzat la rutina _IniPantalla.
        ;       Declaraci en C:
        ;               void EscriureString (BYTE fila, BYTE columna,
        ;                                    char * string, BYTE atribut);


EXTRN _EsborrarPantalla:FAR
        ;  Omple tota la pantalla de carcters blancs (' ', espai, codi ASCII
        ;  32) amb l'atribut que se li indica. Tamb es poden utilitzar ins-
        ;  truccions de tractament de strings (concretament, REP STOSW). La
        ;  informaci d'on es troba mapejada la pantalla l'obt de la variable
        ;  que ha inicialitzat la rutina _IniPantalla.
        ;       Declaraci en C:
        ;               void EsborrarPantalla (BYTE atribut);


EXTRN _QuinCarAtr:FAR
        ;  Accedeix a la posici de pantalla indicada i retorna la parella
        ;  (carcter, atribut) que es troba en aquella posici, el carcter
        ;  a la part baixa (LSB) del resultat i l'atribut a la part alta
        ;  (MSB). La informaci d'on es troba mapejada la pantalla l'obt
        ;  de la variable que ha inicialitzat la rutina _IniPantalla.
        ;       Declaraci en C:
        ;               WORD QuinCarAtr (BYTE fila, BYTE columna);

