
;;  -------------------------------------------------------------------
;;  NOM:        TECL_INT.INC
;;  CREAT PER:  Coordinador EC I (2000/2001)
;;  DATA:       23/ABR/2001
;;  DESCRIPCIO: fitxer amb la declaraci, en format assemblador, de
;;              les subrutines que permeten accedir al teclat amb sin-
;;              cronitzaci per interrupci.
;;  -------------------------------------------------------------------



;       Declaraci de PROCEDIMENTS pblics del mdul:


EXTRN _IniTeclatINT:FAR
        ;       Inicialitza la variable que permet la comunicaci amb
        ;       la RSI del teclat i carrega el Vector d'Interrupcions
        ;       amb la rutina de servei del teclat (cridant la rutina
        ;       CanviarVectInt) i guarda una copia del que hi havia
        ;       per restaurar-lo posteriorment.
        ;       Cal cridar aquesta subrutina una vegada, abans de qual-
        ;       sevol crida a _LlegirTeclatINT. */
        ;       Declaraci en C:
        ;               void IniTeclatINT (void);


EXTRN _HiHaTecla:FAR
        ;       Verifica si hi ha alguna tecla pendent de ser llegida
        ;       (amb una crida a _LlegirTeclatINT), retornant el valor
        ;       1 si s aix i 0 si no s'ha pitjat cap tecla. Aquesta
        ;       funci es pot utilitzar per evitar quedar-se bloquejat
        ;       en la crida a _LlegirTeclatINT.
        ;       Declaraci en C:
        ;               BYTE HiHaTecla (void);


; RSIteclat
        ;  Aquesta rutina es troba al fitxer TECL_INT.ASM per no s
        ;  pblica. s la rutina que s'activa a cada pulsaci d'una tecla.
        ;  Permet que la tecla pulsada es pugui llegir amb la rutina que
        ;  es descriu a continuaci.


EXTRN _LlegirTeclatINT:FAR
        ;       Llegeix el teclat per interrupcions, esperant que es premi
        ;       una tecla, si no s'ha premut abans. Funciona d'acord amb la
        ;       rutina de servei d'interrupci anterior. Noms far cas quan
        ;       la tecla baixi ("make") i no quan pugi ("break"). El valor
        ;       retornat s el codi de rastreig (scancode). */
        ;       Declaraci en C:
        ;               BYTE LlegirTeclatINT (void);


EXTRN _FiTeclatINT:FAR
        ;       Desf les inicialitzacions necessries per desactivar
        ;       la lectura del teclat per interrupcions. En concret
        ;       descarrega/restaura el Vector d'Interrupcions (cridant
        ;       a CanviarVectInt) amb la rutina de servei del teclat
        ;       ORIGINAL, guardada per _IniTeclatINT.
        ;       Cal cridar aquesta rutina quan s'hagi acabat de treballar
        ;       amb el teclat per interrupcions i abans d'acabar el pro-
        ;       grama, doncs altrament, quan es pitgi una tecla, l'ordi-
        ;       nador es "penjar".
        ;       Declaraci en C:
        ;               void FiTeclatINT (void);


