;;  -------------------------------------------------------------------
;;  NOM:        VECT_INT.ASM
;;  CREAT PER:  Coordinador EC I (2000/2001)
;;  DATA:       23/ABR/2001
;;  DESCRIPCIO: fitxer en "ASM" amb subrutina d'accs al vector
;;              d'interrupcions.
;;  -------------------------------------------------------------------

        ; SUBRUTINA PUBLICA D'AQUEST MODUL:
PUBLIC _CanviarVectInt


_DATA   SEGMENT WORD PUBLIC 'DATA'
_DATA   ENDS


_BSS    SEGMENT WORD PUBLIC 'BSS'
_BSS    ENDS


DGROUP  GROUP   _DATA, _BSS


ASSUME cs:VECT_INT_CODI, ds:DGROUP


VECT_INT_CODI SEGMENT BYTE PUBLIC 'CODE'

;;  *******************************************************************
;;    RSI CanviarVectInt (BYTE NumInt, RSI NovaRSI);
;;
;;          Subrutina d'accs al controlador d'interrupcions:
;;              assigna una nova rutina de servei d'interrupci a una
;;              de les posicions del vector d'interrupcions (VI),
;;              retornant l'adrea de l'anterior rutina de servei, per
;;              tal de restaurar-la ms endavant (amb una nova crida).
;;  *******************************************************************

_CanviarVectInt PROC FAR
        push    bp
        mov     bp, sp          ; muntar Enlla dinmic
        push    es              ; guardar registres que es modifiquen
        push    bx

        mov     bx, 0
        mov     es, bx          ; ES: segment VI (0)
        mov     bl, [bp+6]      ; BX: NumInt
        shl     bx, 1
        shl     bx, 1           ; BX: desplaament VI (NumInt*4)

        pushf                   ; guardar valor del flag d'interrupci
        cli                     ; desactivar TOTES les interrupcions

        mov     ax, [bp+8]      ; AX: Desplaament NovaRSI
        mov     dx, [bp+10]     ; DX: Segment NovaRSI

        xchg    ax, es:[bx]     ; Desplaament RSI Nova/Antiga
        xchg    dx, es:[bx+2]   ; Segment RSI Nova/Antiga

        popf                    ; recuperar valor del flag d'interrupci

        pop     bx              ; recuperar registres modificats
        pop     es
        pop     bp
        ret
_CanviarVectInt ENDP


VECT_INT_CODI ENDS

        END
