;;  -------------------------------------------------------------------
;;  NOM:        WORM.ASM
;;  CREAT PER:  Sergio Blanco Cuaresma
;;  DATA:       31/05/2001
;;  DESCRIPCIO: Subrutines en ensamblador del joc tron, mostra 2 cucs
;;		per pantalla i fa que tinguin moviment
;;  -------------------------------------------------------------------


INCLUDE pantalla.inc    ; Subrutines _IniPantalla, _EscriureString
INCLUDE vect_int.inc    ; Subrutina _CanviarVectInt


TICS_PER_SEGON EQU 3   ; Nmero d'IRQ0 per segon

IRQ_RELLOTGE EQU 0
INT_RELLOTGE EQU IRQ_RELLOTGE+8

CERT EQU 1
FALS EQU 0

; Propietats de pantalla
ATRIBUT_BORDE	EQU	32
ATRIBUT_LLETRES EQU	248
ATRIBUT_FOREGROUND EQU	16

        ; SUBRUTINES PBLIQUES D'AQUEST MDUL:
public _IniWorm
public _FiWorm

public _StartWorm
public _StopWorm

public _Direccio

_DATA   SEGMENT WORD PUBLIC 'DATA'
    StringWorm DB " ",0
    Jugador1Campio DB "Campio: Jugador 1",0
    Jugador2Campio DB "Campio: Jugador 2",0
_DATA   ENDS


_BSS    SEGMENT WORD PUBLIC 'BSS'
    tics        DB ?
    aturat      DB ?
    
    ;Player 1
    direccio1	DB ?
    Fila1        DB ?
    Columna1     DB ?
    Atribut1     DB ?

    ;Player 2
    direccio2	DB ?
    Fila2        DB ?
    Columna2     DB ?
    Atribut2     DB ?

    AntigaRSI   DD ?
_BSS    ENDS


DGROUP  GROUP   _DATA, _BSS


ASSUME cs:WORM_CODI, ds:DGROUP


WORM_CODI SEGMENT BYTE PUBLIC 'CODE'


;;  *******************************************************************
;;    void recuadre (void);
;;
;;       Subrutina interna d'inicialitzaci de la pantalla:
;;		Dibuixa un recuadre a pantalla i el fons
;;  *******************************************************************

_Recuadre PROC FAR
	push	ax
	push	cx
	
	; Fons de la pantalla
        mov	ax, ATRIBUT_FOREGROUND
        push	ax
        call	_EsborrarPantalla
        add	sp, 2
        	
	mov	cx, 80
	
	;Recuadres
linea1:				;Linea horitzontal superior
	mov     al, ATRIBUT_BORDE
        push    ax
        mov     ax, SEG StringWorm
        push    ax
        mov     ax, OFFSET StringWorm
        push    ax
        ;Col
        dec	cx	; Fem que agafi el rang 79-0 (no 80-1)
        push    cx
        inc	cx
        ;Fila
        mov     al, 0
        push    ax
        Call    _EscriureString
        add     sp, 10		;Oblidem parametres
        loop	linea1;		;Repetim fin omplir tota la linea

	mov	cx, 80
linea2:				;Linea horitzontal inferior
	mov     al, ATRIBUT_BORDE
        push    ax
        mov     ax, SEG StringWorm
        push    ax
        mov     ax, OFFSET StringWorm
        push    ax
        ;Col
        dec	cx	; Fem que agafi el rang 79-0 (no 80-1)
        push    cx
        inc	cx
        ;Fila
        mov     al, 24
        push    ax
        Call    _EscriureString
        add     sp, 10		;Oblidem parametres
        loop	linea2;		;Repetim fin omplir tota la linea

	mov	cx, 24
linea3:				;Linea vertical esquerra
	mov     al, ATRIBUT_BORDE
        push    ax
        mov     ax, SEG StringWorm
        push    ax
        mov     ax, OFFSET StringWorm
        push    ax
        ;Col
        mov     al, 0
        push    ax
        ;Fila
        push    cx
        Call    _EscriureString
        add     sp, 10		;Oblidem parametres
        loop	linea3;		;Repetim fin omplir tota la linea

	mov	cx, 24
linea4:				;Linea vertical dreta
	mov     al, ATRIBUT_BORDE
        push    ax
        mov     ax, SEG StringWorm
        push    ax
        mov     ax, OFFSET StringWorm
        push    ax
        ;Col
        mov     al, 79
        push    ax
        ;Fila
        push    cx
        Call    _EscriureString
        add     sp, 10		;Oblidem parametres
        loop	linea4;		;Repetim fin omplir tota la linea

        pop	cx
        pop	ax
	ret
_Recuadre ENDP


;;  *******************************************************************
;;    void IniWorm (BYTE fila1, BYTE columna1, BYTE atribut1, 
;;	BYTE direccio1, BYTE fila2, BYTE columna2, BYTE atribut2, 
;;	BYTE direccio2);
;;
;;       Subrutina d'inicialitzaci dels worms:
;;		Dibuixa el worms del jugadors a les columnes indicades
;;		amb els atributs indicats. A mes crida a _Recuadre
;;		per dibuixar tota la pantalla. I finalment canvia
;;		al vector d'int. la direccio del teclat per RSItimer.
;;  *******************************************************************

_IniWorm PROC FAR
        push    bp
        mov     bp, sp          ; muntar Enlla dinmic
        push    ax              ; guardar registres que es modifiquen
        push    dx

        mov     al, [bp+6]      ; Guardar copia dels parametres del player 1
        mov     Fila1, al
        mov     al, [bp+8]
        mov     Columna1, al
        mov     al, [bp+10]
        mov     Atribut1, al
        mov     al, [bp+12]
        mov	direccio1, al	; Direccio 1=Right, 2=Up, 3=Left, 4=Down

        mov     al, [bp+14]      ; Guardar copia dels parametres del player 2
        mov     Fila2, al
        mov     al, [bp+16]
        mov     Columna2, al
        mov     al, [bp+18]
        mov     Atribut2, al
        mov     al, [bp+20]
        mov	direccio2, al	; Direccio 1=Right, 2=Up, 3=Left, 4=Down

                ; Inicialitzaci de DISPOSITIUS:
        call    _IniPantalla
	call	_Recuadre	;Dibuixem el recuadre
	
	;Dibuixem Player 1
	
        mov     al, Atribut1
        push    ax
        mov     ax, SEG StringWorm
        push    ax
        mov     ax, OFFSET StringWorm
        push    ax
        mov     al, Columna1
        push    ax
        mov     al, Fila1
        push    ax
        Call    _EscriureString
        add     sp, 10		;Oblidem parametres

	;Dibuixem player 2

        mov     al, Atribut2
        push    ax
        mov     ax, SEG StringWorm
        push    ax
        mov     ax, OFFSET StringWorm
        push    ax
        mov     al, Columna2
        push    ax
        mov     al, Fila2
        push    ax
        Call    _EscriureString
        add     sp, 10		;Oblidem parametres

	;Canviem el vector d'interrupcions per controlar el timer
        mov     ax, SEG RSItimer
        push    ax
        mov     ax, OFFSET RSItimer
        push    ax
        mov     al, INT_RELLOTGE
        push    ax
        call    _CanviarVectInt         ; AntigaRSI <-- CanvVI (8, RSIrell);
        add     sp, 6		;Oblidem parametres
        mov     WORD PTR [AntigaRSI], ax
        mov     WORD PTR [AntigaRSI+2], dx

        pop     dx              ; recuperar registres modificats
        pop     ax
        pop     bp
        ret
_IniWorm ENDP


;;  *******************************************************************
;;    void direccio (BYTE direccio, BYTE player);
;;
;;       Subrutina per canviar la direccio d'un jugador:
;;		Canvia la direccio (1=right, 2=up, 3=left, 4=down)
;;		d'un dels jugadors (1 o 2)
;;  *******************************************************************

_Direccio PROC FAR
        push    bp
        mov     bp, sp          ; muntar Enlla dinmic
        push	ax
        mov     al, [bp+6]      ; Canviar la direccio
        mov     ah, [bp+8]      ; del Player
        cmp	ah, 1
        jne	player2
        mov	direccio1, al	; Canviem la direccio player 1
        jmp	fidireccio
player2:
        mov	direccio2, al	; Canviem la direccio player 2
fidireccio:
        pop	ax
        pop     bp
        ret
_Direccio ENDP


;;  *******************************************************************
;;    void FiRellotge (void);
;;
;;       Subrutina de finalitzaci:
;;		Recuperen l'adrea del vector d'int. de la RSI del
;;		timer original i esborrem la pantalla.
;;  *******************************************************************

_FiWorm PROC FAR
        push    ax              ; guardar registres que es modifiquen
        push    dx

                ; Finalitzaci de DISPOSITIUS:
        mov     ax, WORD PTR [AntigaRSI+2]
        push    ax
        mov     ax, WORD PTR [AntigaRSI]
        push    ax
        mov     al, INT_RELLOTGE
        push    ax
        call    _CanviarVectInt         ; CanviarVectInt (8, AntigaRSI);
        add     sp, 6
        mov	ax, 7
        push	ax
        call	_EsborrarPantalla
        add	sp, 2

        pop     dx              ; recuperar registres modificats
        pop     ax
        ret
_FiWorm ENDP



;;  *******************************************************************
;;    void StartWorm (void);
;;
;;       Subrutina de posta en marxa dels worms:
;;         POSA EN MARXA els worms que apareixen per pantalla.
;;  *******************************************************************

_StartWorm PROC FAR
        mov     aturat, FALS
        ret
_StartWorm ENDP


;;  *******************************************************************
;;    void StopWorm (void);
;;
;;       Subrutina d'aturada dels worms:
;;         ATURA els worms que apareixen per pantalla.
;;  *******************************************************************

_StopWorm PROC FAR
        mov     aturat, CERT
        ret
_StopWorm ENDP


;;  *******************************************************************
;;    void RSItimer (void);
;;
;;       Subrutina d'interrupci del timer:
;;         Aquesta rutina es troba al fitxer WORM.ASM pero no es
;;         publica. es la rutina que s'activa a cada 'TIC' del timer.
;;         Realitza el control del moviment dels worms, vigila que no
;;	   hi hagui colisions (si n'hi ha atura el joc i diu qui es
;;	   el guanyador).
;;  *******************************************************************

RSItimer PROC
        push    ax              ; guardar registres que es modifiquen
        push    ds

        mov     ax, DGROUP      ; Inicialitzar DS per poder accedir
        mov     ds, ax          ;       al segment de dades (DGROUP)

        cmp     aturat, CERT    ; S'ha de comptar?
        jne      noaturat            ; No, rellotge aturat
	jmp	fsi1		;Era un salt massa llunya, utilitzem aquesta tecnica
noaturat:	
        inc     tics
        cmp     tics, TICS_PER_SEGON
        je     dibuixar
        jmp	fsi2		;Era un salt massa llunya, utilitzem aquesta tecnica
dibuixar:        

                ; Ha passat x milisegons: Dibuixem worm
        mov	tics, 0

; >>>>>>>>>>>> Decidim cap a on incrementar segons la direccio PLAYER 1
        cmp	direccio1, 1	;Si anem cap a la dreta
        jne	noright1
	inc	Columna1	;incrementem la columna
	jmp	final1
noright1:
	cmp	direccio1, 2	;Si anem cap adalt
	jne	noup1
	dec	Fila1		;decrementem la fila
	jmp	final1
noup1:
	cmp	direccio1, 3	;Si anem cap a l'esquerra
	jne	noleft1
	dec	Columna1	;decrementem la columna
	jmp	final1
noleft1:
	inc	Fila1		;Sino, anem cap abaix (incrementem la fila)
final1:
	
	;Ens preparem per dibuixar la nova posicio del worm
	mov     al, Atribut1
        push    ax
        mov     ax, SEG StringWorm
        push    ax
        mov     ax, OFFSET StringWorm
        push    ax
        mov     al, Columna1
        push    ax
        mov     al, Fila1
        push    ax
        ; Aprofitem que tenim la columna i fila a la pila per mirar que
        ; hi ha a la nova posicio
        Call	_QuinCarAtr
        cmp	ah, Atribut1		;Si a la nova posicio estem nosaltres
        je	colisio1
        cmp	ah, Atribut2		;o l'altre worm
        je	colisio1
        cmp	ah, ATRIBUT_BORDE	;o es un extrem saltem a colisio1
        je	colisio1
        Call    _EscriureString		;Sino, dibuixem
        jmp	nocolisio1
colisio1:
	;Mostrem lletres donant com a campio al jugador 2
	;i aturem el joc
	mov     al, ATRIBUT_LLETRES
        push    ax
        mov     ax, SEG Jugador2Campio
        push    ax
        mov     ax, OFFSET Jugador2Campio
        push    ax
        ;Columna
        mov     al, 31
        push    ax
        ;Fila
        mov	al, 8
        push    ax
        Call    _EscriureString
        add     sp, 10		;Oblidem parametres
	; Aturem el joc
	Call	_StopWorm
	jmp	finalRSI

nocolisio1:			;No hi ha colisio del player 1
        add     sp, 10		;Oblidem parametres


	;Repetim el procediment pel player 2
; >>>>>>>>>>>> Decidim cap a on incrementar segons la direccio PLAYER 2
        cmp	direccio2, 1	;Si anem cap a la dreta
        jne	noright2
	inc	Columna2	;incrementem la columna
	jmp	final2
noright2:
	cmp	direccio2, 2	;Si anem cap adalt
	jne	noup2
	dec	Fila2		;decrementem la fila
	jmp	final2
noup2:
	cmp	direccio2, 3	;Si anem cap a l'esquerra
	jne	noleft2
	dec	Columna2	;decrementem la columna
	jmp	final2
noleft2:
	inc	Fila2		;Sino, anem cap abaix (decrementem fila)
final2:
	
	;Ens preparem per dibuixar la nova posicio del worm
	mov     al, Atribut2
        push    ax
        mov     ax, SEG StringWorm
        push    ax
        mov     ax, OFFSET StringWorm
        push    ax
        mov     al, Columna2
        push    ax
        mov     al, Fila2
        push    ax
        ; Aprofitem que tenim la columna i fila a la pila per mirar que
        ; hi ha a la nova posicio
        Call	_QuinCarAtr
        cmp	ah, Atribut1		;Si a la nova posicio esta l'altre worm
        je	colisio2
        cmp	ah, Atribut2		;o nosaltres
        je	colisio2
        cmp	ah, ATRIBUT_BORDE	;o es un extrem, saltem a colisio2
        je	colisio2
        Call    _EscriureString		;No hem colisionat
        jmp	nocolisio2
colisio2:
	;Mostrem lletres donant com a campio al jugador 1
	;i aturem el joc
	mov     al, ATRIBUT_LLETRES
        push    ax
        mov     ax, SEG Jugador1Campio
        push    ax
        mov     ax, OFFSET Jugador1Campio
        push    ax
        ;Columna
        mov     al, 31
        push    ax
        ;Fila
        mov	al, 8
        push    ax
        Call    _EscriureString
        add     sp, 10		;Oblidem parametres
        ;Aturem el joc
	Call	_StopWorm

finalRSI:	;Aqui venim si hi ha colisio del player 1
nocolisio2:	;No hi ha colisio del player 2
        add     sp, 10		;Oblidem parametres


fsi2:
fsi1:
                ; EOI
        mov     al, 20h
        out     20h, al

        pop     ds
        pop     ax
        iret
RSItimer ENDP




WORM_CODI ENDS

        END
