/*  *******************************************************************
    NOM:        WORM.H
    CREAT PER:  Sergio Blanco Cuaresma
    DATA:       31/05/2001
    DESCRIPCIO: Capalera de worm.asm
    ******************************************************************* */



        /* Per impedir mltiples "inclusions" d'aquest fitxer capalera: */
#ifndef RELLOTGE_H
#define RELLOTGE_H

#include "tipus.h"    /* Definicions de tipus elementals: BYTE, WORD, ADR */

        /* Per a que funcioni tamb compilant en versi C++ */
#ifdef __cplusplus
extern "C" {
#endif


#define TICS_PER_SEGON 18       /* Nmero d'IRQ0 per segon */



/***    Declaraci de FUNCIONS del mdul                      ***/


extern void IniWorm (BYTE fila1, BYTE columna1, BYTE atribut1, BYTE direccio1, BYTE fila2, BYTE columna2, BYTE atribut2, BYTE direccio2);

       /*Subrutina d'inicialitzaci dels worms:
		Dibuixa el worms del jugadors a les columnes indicades
		amb els atributs indicats. A mes crida a _Recuadre
		per dibuixar tota la pantalla. I finalment canvia
		al vector d'int. la direccio del teclat per RSItimer.*/



extern void FiWorm (void);

       /*Subrutina de finalitzaci:
		Recuperen l'adrea del vector d'int. de la RSI del
		timer original i esborrem la pantalla.*/


extern void StartWorm (void);

       /*Subrutina de posta en marxa dels worms:
         POSA EN MARXA els worms que apareixen per pantalla.*/


extern void StopWorm (void);

       /*Subrutina d'aturada dels worms:
         ATURA els worms que apareixen per pantalla.*/


extern void Direccio (BYTE direccio, BYTE player);

       /*Subrutina per canviar la direccio d'un jugador:
		Canvia la direccio (1=right, 2=up, 3=left, 4=down)
		d'un dels jugadors (1 o 2)*/



   /* void recuadre (void);

       Subrutina interna d'inicialitzaci de la pantalla:
		Dibuixa un recuadre a pantalla i el fons*/

   /* static void RSItimer (void);
    
       Subrutina d'interrupci del timer:
         Aquesta rutina es troba al fitxer WORM.ASM pero no es
         publica. es la rutina que s'activa a cada 'TIC' del timer.
         Realitza el control del moviment dels worms, vigila que no
	 hi hagui colisions (si n'hi ha atura el joc i diu qui es
	 el guanyador).*/




#ifdef __cplusplus
}
#endif


#endif
